from __future__ import print_function
import pyintegrate
import integrate
import time
import numpy as np
#
# standard python
pstart =time.time()
a = pyintegrate.integrate_f(0,5,100000)
pend = time.time()
print("{:17s} elapsed {:.5f} value={:.6f}".format('python (slow)', pend-pstart,a))
#
# slow cython almost like python
start =time.time()
b = integrate.integrate_fast(0,5,100000)
end = time.time()
print("{:17s} elapsed {:.5f} value={:.6f}".format('cython (slow)', end-start,b))
#
# faster cython using cdef for f() and math from C but uses also a for loop
start =time.time()
c = integrate.integrate_faster(0,5,100000)
end = time.time()
print("{:17s} elapsed {:.5f} value={:.6f}".format('cython (faster)', end-start,c))
#
# fastest cython, same as faster but using a while loop thus no generator or list
# need for loop
start =time.time()
d = integrate.integrate_fastest(0.,5.,100000)
end = time.time()
print("{:17s} elapsed {:.5f} value={:.6f}".format('cython (fastest)', end-start,b))
print("speedup:",(pend-pstart)/(end-start))
#import matplotlib.pyplot as plt
#x = np.linspace(0,5,1000)
#y = [pyintegrate.f(xi) for xi in x]
#plt.plot(x,y)
#plt.show()


